<?php
/**
 * @package WordPress
 * @subpackage Alter_Serendipity_Theme
 * @author David Coll - http://funkybudha.net
 * @copyright GNU GENERAL PUBLIC LICENSE - GPLv3
 */
?>
<?php
// Do not delete these lines
if (!empty($_SERVER['SCRIPT_FILENAME']) && 'comments.php' == basename($_SERVER['SCRIPT_FILENAME']))
	die ('Please do not load this page directly. Thanks!');

if ( post_password_required() ) { ?>
	<p class="nocomments"><?php _e('This post is password protected. Enter the password to view comments.', theme_ext_domain()) ?></p>
<?php 
	return;
}
?>

<?php if ( comments_open() ) : ?>
	<h3 id="comments">
		<?php comments_number(__('No responses yet', theme_ext_domain()), __('One response', theme_ext_domain()), __('% responses', theme_ext_domain()) );?>
		<a href="<?php echo get_post_comments_feed_link(); ?>"><img alt="comments RSS" src="<?php bloginfo('stylesheet_directory'); ?>/img/rss_small.png"/></a>
	</h3>
<?php endif;?>

<?php 
if ( have_comments() ) :?>
	<div class="navigation">
		<div class="alignleft"><?php previous_comments_link() ?></div>
		<div class="alignright"><?php next_comments_link() ?></div>
	</div>

	<ol class="commentlist">
	<?php wp_list_comments('avatar_size=50'); ?>
	</ol>

	<div class="navigation">
		<div class="alignleft"><?php previous_comments_link() ?></div>
		<div class="alignright"><?php next_comments_link() ?></div>
	</div>
<?php else : // this is displayed if there are no comments so far 
?>

	<?php if ( comments_open() ) : ?>
		<!-- If comments are open, but there are no comments. -->

	<?php else : // comments are closed 
?>
		<!-- If comments are closed. -->
		<p class="nocomments"><?php _e('Comments are closed.', theme_ext_domain()) ?></p>

	<?php endif; ?>
<?php endif; ?>

<?php /*=============== This section is dedicated to the form field !! ======================*/ ?>


<?php if ( comments_open() ) : ?>
<div id="respond">
	<h3><?php comment_form_title( __('Leave a comment', theme_ext_domain()), __('Leave a Reply to %s', theme_ext_domain()) ); ?></h3>
	
	<div class="cancel-comment-reply">
		<small><?php cancel_comment_reply_link(); ?></small>
	</div>
	
<?php if ( get_option('comment_registration') && !is_user_logged_in() ) : ?>
	<p><?php printf( __('You must be %1$slogged in%2$s to post a comment.', theme_ext_domain()), '<a href="'.wp_login_url( get_permalink() ).'">', '</a>') ?></p>
<?php else : ?>
	
	<form action="<?php echo get_option('siteurl'); ?>/wp-comments-post.php" method="post" id="commentform">
<?php if ( is_user_logged_in() ) : ?>
	<p><?php _e('Logged in as ', theme_ext_domain()) ?><a href="<?php echo get_option('siteurl'); ?>/wp-admin/profile.php"><?php echo $user_identity; ?></a>.</p>
<?php else : ?>
	<p>
		<input type="text" name="author" id="author" value="<?php echo esc_attr($comment_author); ?>" size="22" tabindex="1"/>
		<label for="author">
			<small><?php _e('Name', theme_ext_domain())?> <?php if ($req) _e('(required)', theme_ext_domain()); ?></small>
		</label>
	</p>
	<p>
		<input type="text" name="email" id="email" value="<?php echo esc_attr($comment_author_email); ?>" size="22" tabindex="2"/>
		<label for="email">
			<small><?php _e('Mail (will not be published)', theme_ext_domain())?> <?php if ($req) _e('(required)', theme_ext_domain()); ?></small>
		</label>
	</p>
	<p>
		<input type="text" name="url" id="url" 
			value="<?php echo esc_attr($comment_author_url); ?>" size="22" tabindex="3" />
		<label for="url">
			<small><?php _e('Website', theme_ext_domain())?></small>
		</label>
	</p>
<?php endif; 
// Now starting to edit the real comment box ...
?>
	<p class="sober">
		<textarea name="comment" id="comment" cols="57" rows="10" tabindex="4"></textarea><br/>
		<span class="comment-info"><strong>XHTML:</strong> <?php _e('You can use these tags: ', theme_ext_domain())?><?php echo allowed_tags(); ?></span>
	</p>
<?php /*--Options at the bottom of the comment area--*/ ?>
	<div class="comment-options">
		<div class="comment-submit">
			<input name="submit" type="submit" id="submit" tabindex="5" value="<?php esc_attr_e('Submit Comment', theme_ext_domain())?>" />
		<?php comment_id_fields(); ?>
		</div>
		<div class="comment-form-options">
			<?php do_action('comment_form', $post->ID); ?>
		</div>	
	</div>
	</form>
	
	<?php endif;?>
</div>
<?php endif;?>
