<?php
/**
 * @package WordPress
 * @subpackage Alter_Serendipity_Theme
 * @author David Coll - http://funkybudha.net
 * @copyright GNU GENERAL PUBLIC LICENSE - GPLv3
 */
?>
<?php
/*--Set header to use XHTML 1.1 strict - Not working with most plugins--*/
/*add_filter( 'pre_option_html_type', 'theme_set_html_type' );
function theme_set_html_type(){
	if (strstr($_SERVER['HTTP_ACCEPT'], 'application/xhtml+xml')) {
		return "application/xhtml+xml";
	}else{
		return "text/html";
	}
}
*/
// Instantiate theme class
$theme_class = new theme_class();

class theme_class{
	var $theme_url = null;
	var $theme_path = null;

	var $domain = 'theme_domain'; //i18n text domain - will be set to directory name
	var $t_name = null; // Theme name
	var $t_version = null; // Theme version
	var $t_info_url = null;
	
	var $first_post_img = null; //Used for excerpt right image - theme_fn_get_post_first_image()
	
	var $options = array(
						'theme_opt_backgroundColor' => '#021728',
						'theme_opt_googleAnalyticID_used' => '0',
						'theme_opt_googleAnalyticID' => 'UA-XXXXXXX-Y',
						'theme_opt_adRotate_group1' => '0',
						'theme_opt_adRotate_group2' => '0',
						'theme_opt_automaticHideLeft' => '1',
						'theme_opt_delayBeforeHideLeft' => '10',
						'theme_opt_keepDesignerPromoCode' => '0',
						'theme_opt_image_background_show' => '1',
						'theme_opt_image_background' => 'back_white_shadow_right.png',
						'theme_opt_image_logoBackground_show' => '1',
						'theme_opt_image_logoBackground' => 'yingYang_DavidColl_originalArt.png',
						'theme_opt_image_favicon' => 'funky.ico'
						);
	var $options_list = array();				
	
	function theme_class(){
		$this->__loadThemeDetails();
		
		load_theme_textdomain($this->domain, $this->theme_path . '/languages');

		$this->theme_fn_setOptions();
		add_action('wp_head', 	array($this, 'theme_fn_wp_head'));
		add_action('admin_menu',array($this, 'theme_fn_add_admin'));
		
		if (isset($_REQUEST['preview']) && current_user_can('edit_themes')) {
			add_action('wp_head', array($this, 'theme_fn_preview_head'));
		}
		
		$this->setWidgetSidebarsStyle();
	}
	function __loadThemeDetails(){
		$this->theme_url = get_theme_root_uri() . '/' . basename(dirname(__FILE__));
		$this->theme_path = get_theme_root() . '/' . basename(dirname(__FILE__));
		$this->domain = basename(dirname(__FILE__));

		$theme_data = get_theme_data( $this->theme_path."/style.css");	
		$this->t_name = $theme_data['Name'];
		$this->t_version = $theme_data['Version'];
		$this->t_info_url = $theme_data['URI'];
	}
	
	/*---- Retrieves saved options and overwrite the defaults ----*/
	function theme_fn_setOptions(){
		foreach($this->options as $k => $v){
			$var = esc_attr(get_option($k));
			if ( $var != $v && $var != '') {
				$this->options[$k] = $var; 
			}
			$this->options_list[] = $k;
		}
	}
	
	/*---- Set widgetized sidebars style----*/
	function setWidgetSidebarsStyle(){
		register_sidebar(array(
		    'name'          => __('Left top section (fixed)', $this->domain),
		    'id'            => 'theme_sidebar_left_top',
		    'before_widget' => '<div class="links_box left_top_section">',
		    'after_widget'  => '</div>',
		    'before_title'  => '<h2 class="left_top_title">',
		    'after_title'   => '</h2>' ));
		
		register_sidebar(array(
		    'name'          => __('Left bottom section (fixed)', $this->domain),
		    'id'            => 'theme_sidebar_left_bottom',
		    'before_widget' => '<div class="links_box left_bottom_section">',
		    'after_widget'  => '</div>',
		    'before_title'  => '<h2 class="left_bottom_title">',
		    'after_title'   => '</h2>' ));
		
		register_sidebar(array(
		    'name'          => __('Right section (normal)', $this->domain),
		    'id'            => 'theme_sidebar_right_bottom',
		    'before_widget' => '<div class="right_bottom_section">',
		    'after_widget'  => '</div>',
		    'before_title'  => '<h2 class="right_bottom_title">',
		    'after_title'   => '</h2>' ));
	}

	/*==== Output for colorized theme description ====*/
	function theme_fn_wp_head() {
		global $post;
		$includeBackgroundImage = $includeLogoBackgroundImage = null;
		unset($match);
		if (is_single() && get_post_meta($post->ID, 'back_color_used', true) == 'yes'){
			if (preg_match('@#\w{6}@', get_post_meta($post->ID, 'back_color', true), $match)){
				$backgroundColor = $match[0];
			}
		}else{
			$backgroundColor = $this->options['theme_opt_backgroundColor'];
		}
		
		if ($this->options['theme_opt_image_background_show'] == '1'){
			$includeBackgroundImage = 'html, #container {background-image: url("'. $this->theme_url . '/img/backgrounds/' . $this->options['theme_opt_image_background'] .'"); }';
		}
		if ($this->options['theme_opt_image_logoBackground_show'] == '1'){
			$includeLogoBackgroundImage = '#content {	background-image: url("'. $this->theme_url . '/img/backgrounds/' . $this->options['theme_opt_image_logoBackground'] .'"); }';
		}
		
		echo '
<!-- *Start* - Generated by the theme options* -->
<style type="text/css" media="screen">
	html, body, .footer, .links_box li, .sitelinks_hilite{background-color:'. $backgroundColor .'}
'.$includeBackgroundImage.'
'.$includeLogoBackgroundImage.'
</style>';
		if($this->options['theme_opt_googleAnalyticID_used'] == 1) { 
		echo '
<script type="text/javascript">
//<![CDATA[
//]]>
</script>
<script type="text/javascript">
//<![CDATA[
//]]>
</script>
';
		}
		if($this->options['theme_opt_automaticHideLeft'] == 1) { 
		echo '
<script type="text/javascript">
//<![CDATA[
	triggerAutomaticHideLeft();
	function delayedSlideLeft(){ return ' . $this->options['theme_opt_delayBeforeHideLeft'] . '; }
//]]>
</script>
';
		}
		echo "<!-- *End* - Generated by the theme options* -->\n";
	}

	/*==== Instantiate admin menu ====*/
	function theme_fn_add_admin() {
		if ( isset($_GET['page']) && $_GET['page'] == basename(__FILE__) ) {
			if ( isset($_REQUEST['action']) &&  'save' == $_REQUEST['action'] ) {
				check_admin_referer('theme_fn_save_options');
				foreach($this->options as $k => $v){
					update_option($k, strip_tags(stripslashes($_REQUEST[$k]))); 
				}
				header("Location: themes.php?page=functions.php&saved=true");
				die;
			} elseif ( isset($_REQUEST['action']) && 'reset' == $_REQUEST['action'] ) {
				check_admin_referer('theme_fn_reset_options');
				foreach($this->options as $k => $v){
					delete_option($k);
				}
				header("Location: themes.php?page=functions.php&reset=true");
				die;
			}
		}
		add_meta_box($this->domain, __('Specify your theme background color for this post', $this->domain ), array($this, 'theme_fn_edit_box'),'post');
		add_meta_box($this->domain, __('Specify your theme background color for this post', $this->domain ), array($this, 'theme_fn_edit_box'),'page');
		add_action('save_post', array($this, 'theme_fn_save_box_data'));
		
		add_theme_page( sprintf(__( '%s Theme Options', $this->domain ), $this->t_name), 
						__( 'Set theme options', $this->domain ), 
						'edit_themes', 
						basename(__FILE__), 
						array($this, 'theme_fn_admin') );
		add_thickbox();
		wp_enqueue_script( 'theme-preview' );
		wp_enqueue_script( 'prototype' );
		wp_enqueue_script( 'scriptaculous.js?load=effects,dragdrop,slider' );
	}

	/*==== Render admin page ====*/
	function theme_fn_admin() {
		if ( isset($_REQUEST['saved']) ) { ?><div id="message1" class="updated fade"><p><?php printf(__('%1$s theme options saved. %2$sView site.</a>', $this->domain), $this->t_name, '<a href="'.get_bloginfo('home').'/">'); ?></p></div><?php }
		if ( isset($_REQUEST['reset']) ) { ?><div id="message2" class="updated fade"><p><?php printf(__('%s theme options reset.', $this->domain), $this->t_name); ?></p></div><?php } ?>
	
	<div class="wrap" id="<?php echo $this->domain?>-options">
		<h2><?php printf(__( '%1$s v%2$s Theme Options', $this->domain ), $this->t_name, $this->t_version); ?></h2>
		<p>
			<a rel="license" href="http://www.gnu.org/licenses/gpl.html" style="float:right">
				<img alt="GNU GENERAL PUBLIC LICENSE - GPLv3" style="border-width:0" src="http://www.gnu.org/graphics/gplv3-88x31.png" />
			</a>
			<?php 	printf( __('Thank you for selecting the %1$s theme. ', $this->domain),
						'<a style="text-decoration:none;" href="'.$this->t_info_url.'" title="'.sprintf(esc_attr__('%s theme for WordPress', $this->domain), $this->t_name).'">'.$this->t_name.'</a>'
						);?>
			<br/>
			<?php 	printf( __('This theme made by %1$s is licensed under the %2$sGNU general public license - GPLv3%3$s.', $this->domain),
							'<a style="text-decoration:none;" href="http://funkybudha.net/" title="http://funkybudha.net" rel="me designer">David Coll</a>',
							'<a style="text-decoration:none;" rel="license" href="http://www.gnu.org/licenses/gpl.html">',
							'</a>'  );?>
			<?php  	$this->theme_fn_donate()?>
			<strong>
			<?php	printf( __('If you find this theme useful, please consider %1$sdonating%2$s.', $this->domain), 
						'<label for="submit_paypal" style="text-decoration:underline;">', '</label>');?>
			</strong>
			<br/><br/>
		</p>
			<hr style="width:50%"/>
		<p>
			<?php	printf( __('This page should be self-explanatory, but if you\'re curious of details, please read the %1$sdocumentation%2$s for more information about the theme and its advanced features.', $this->domain), 
					 	'<a style="text-decoration:none;" href="'.$this->t_info_url.'" title="'.esc_attr__('See the readme data', $this->domain).'" rel="enclosure" id="readme">', '</a>');?>
		</p>
		<div style="clear:both; text-align:center; border: 1px dotted red;">
			<?php	_e('You must click on <i><u>S</u>ave Options</i> to save any changes. You can also discard your changes and reload the default settings by clicking on <i><u>R</u>eset</i>.', $this->domain) ?>
		</div>
		<form action="<?php echo wp_specialchars( $_SERVER['REQUEST_URI'] ) ?>" method="post">
			<?php wp_nonce_field('theme_fn_save_options'); echo "\n"; ?>
			<h3><?php _e('Theme scheme', $this->domain); ?></h3>
			<table class="form-table" summary="Theme color scheme options">
				<tr valign="top">
					<th scope="row"><label for="theme_opt_backgroundColor"><?php _e('Background color', $this->domain); ?></label></th> 
					<td>
						<input id="theme_opt_backgroundColor" name="theme_opt_backgroundColor" type="text" class="text" value="<?php $this->theme_fn_select_color(); ?>" tabindex="1" size="10" /><br />
						<a title="<?php esc_attr_e('Pop-up a preview screen to help you choose color', $this->domain)?>" 
							class="thickbox thickbox-preview" 
							href="<?php bloginfo('wpurl'); ?>/?preview=1&amp;template=alter_serendipity&amp;stylesheet=alter_serendipity&amp;TB_iframe=true">
							<?php _e('Select your color with the true color picker !', $this->domain); ?></a>
								<p class="info"><?php _e('Click on the link ^ to launch a color selection window. You can set the background color of the theme to your preference. NB. You can set the color for individual articles, you dispose of the same color selector in the edit post window to do so !', $this->domain); ?></p>
					</td>
				</tr>
				<tr>
<?php //TODO: Create an uploader ?><th colspan="2"><i><?php _e("For now, I didn't implement an uploader for your backgrounds. You can add your custom images by copying them into /themes/alter_serendipity/img/backgrounds/", $this->domain); ?></i></th>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="theme_opt_image_background_show"><?php _e('Use the large background image ?', $this->domain); ?></label></th> 
					<td>
						<input type="hidden" id=theme_opt_image_background_show value="0" name="theme_opt_image_background_show"/>
						<input type="checkbox" <?php if($this->options['theme_opt_image_background_show'] == '1'){ echo 'checked="true"';}?> id="theme_opt_image_background_show" value="1" name="theme_opt_image_background_show"/>
						<p class="info"><?php _e('Uncheck this if you do not want the large background image to be shown. Can render the page more rapidly.', $this->domain); ?></p>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="theme_opt_image_background"><?php _e('Background image to use', $this->domain); ?></label></th> 
					<td>
					<img src="<?php echo $this->theme_url . '/img/backgrounds/' . $this->options['theme_opt_image_background'];?>" 
						 style="float:right; width: 100px; border: solid 2px black; background: <?php echo $this->options['theme_opt_backgroundColor'];?>" 
						 id="theme_opt_image_background_thumb"/>
						<select id="theme_opt_image_background" name="theme_opt_image_background">
							<?php echo $this->theme_fn_get_background_image($this->options['theme_opt_image_background']) ?>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="theme_opt_image_logoBackground_show"><?php _e('Use the logo background image ?', $this->domain); ?></label></th> 
					<td>
						<input type="hidden" id=theme_opt_image_logoBackground_show value="0" name="theme_opt_image_logoBackground_show"/>
						<input type="checkbox" <?php if($this->options['theme_opt_image_logoBackground_show'] == '1'){ echo 'checked="true"';}?> id="theme_opt_image_logoBackground_show" value="1" name="theme_opt_image_logoBackground_show"/>
						<p class="info"><?php _e('Uncheck this if you do not want the logo background image to appear on the top left section of your pages.', $this->domain); ?></p>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="theme_opt_image_logoBackground"><?php _e('Background image to use', $this->domain); ?></label></th> 
					<td>
					<img src="<?php echo $this->theme_url . '/img/backgrounds/' . $this->options['theme_opt_image_logoBackground'];?>" 
						 style="float:right; width: 100px; border: solid 2px black; background: <?php echo $this->options['theme_opt_backgroundColor'];?>"
						 id="theme_opt_image_logoBackground_thumb" />
						<select id="theme_opt_image_logoBackground" name="theme_opt_image_logoBackground">
							<?php echo $this->theme_fn_get_background_image($this->options['theme_opt_image_logoBackground']) ?>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="theme_opt_image_favicon"><?php _e('Favicon image to use', $this->domain); ?></label></th> 
					<td>
					<img src="<?php echo $this->theme_url . '/img/favicons/' . $this->options['theme_opt_image_favicon'];?>" 
						 style="float:right; width: 40px; border: solid 2px black; "
						 id="theme_opt_image_favicon" />
						<select id="theme_opt_image_favicon" name="theme_opt_image_favicon">
							<?php echo $this->theme_fn_get_background_image($this->options['theme_opt_image_favicon'], 'favicons') ?>
						</select>
					</td>
				</tr>
			</table>
<script type="text/javascript">
//<![CDATA[
new Event.observe($('theme_opt_image_background'), 'click', function(){ changeBackgroundThumb(this); } );
new Event.observe($('theme_opt_image_logoBackground'), 'click', function(){ changeBackgroundThumb(this); } );

function changeBackgroundThumb(el){
	$(el.id+'_thumb').src = '<?php echo $this->theme_url . '/img/backgrounds/';?>' + $F(el);
}
// ]]>
</script>
			<h3><?php _e('Theme behavior', $this->domain); ?></h3>
			<table class="form-table" summary="Theme behavior">
				<tr>
					<th colspan="2"><?php _e('The left panel (white) as a trigger to hide/show itself. It can be triggered manually and/or automatically after a certain delay once a page is loaded. This functionnality is recommended to support the readability of long articles, dropping the luminosity contrast created by the panel.', $this->domain); ?></th>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="theme_opt_automaticHideLeft"><?php _e('Left panel automatic delayed hiding', $this->domain); ?></label></th> 
					<td>
						<input type="hidden" id=theme_opt_automaticHideLeft value="0" name="theme_opt_automaticHideLeft"/>
						<input type="checkbox" <?php if($this->options['theme_opt_automaticHideLeft'] == '1'){ echo 'checked="true"';}?> id="theme_opt_automaticHideLeft" value="1" name="theme_opt_automaticHideLeft"/>
						<p class="info"><?php _e('Uncheck this if you do not want the left panel to hide itself automatically once a page is loaded. Best for page readability on long text.', $this->domain); ?></p>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="theme_opt_delayBeforeHideLeft"><?php _e('Delay before left panel automatic hiding', $this->domain); ?></label></th> 
					<td>
						<input id="theme_opt_delayBeforeHideLeft" name="theme_opt_delayBeforeHideLeft" type="text" class="text" value="<?php echo $this->options['theme_opt_delayBeforeHideLeft']?>" size="3" />
						<?php _e('seconds', $this->domain); ?><br />
								<p class="info"><?php _e('Sets the time before the left panel folds itself.', $this->domain); ?></p>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="theme_opt_keepDesignerPromoCode"><?php _e("Add designer's promo code link ?", $this->domain); ?></label></th> 
					<td>
						<input type="hidden" id=theme_opt_keepDesignerPromoCode value="0" name="theme_opt_keepDesignerPromoCode"/>
						<input type="checkbox" <?php if($this->options['theme_opt_keepDesignerPromoCode'] == '1'){ echo 'checked="true"';}?> id="theme_opt_keepDesignerPromoCode" value="1" name="theme_opt_keepDesignerPromoCode"/>
						<p class="info"><?php _e('Check this if you want to add the green Dreamhost icon on the right sidebar. Thank you if you decide to do it ;)', $this->domain); ?></p>
					</td>
				</tr>
			</table>
			<h3><?php _e('Personal data to drive your site', $this->domain); ?></h3>
			<p><i>Disabled for Wordpress compliance, enter your tracker manually via widgets.</i></p>
			
			<div style="color: gray">
			<table class="form-table" summary="Personal data for theme">
				<tr valign="top">
					<th scope="row"><label for="theme_opt_googleAnalyticID_used"><?php _e('I use a tracker like Google Analytics to stay in touch with my traffic', $this->domain); ?></label></th> 
					<td>
						<input type="hidden" id="theme_opt_googleAnalyticID_used" value="0" name="theme_opt_googleAnalyticID_used"/>
						<input type="checkbox" disabled="disabled" <?php if($this->options['theme_opt_googleAnalyticID_used'] == '1'){ echo 'checked="true"';}?> id="theme_opt_googleAnalyticID_used" value="1" name="theme_opt_googleAnalyticID_used"/>
						<p class="info"><?php _e('Check this if you use Google Analytics to control the trafic on your site.', $this->domain); ?></p>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="theme_opt_googleAnalyticID"><?php _e('Google Analytics Web Property ID', $this->domain); ?></label></th> 
					<td>
						<input disabled="disabled" id="theme_opt_googleAnalyticID" name="theme_opt_googleAnalyticID" type="text" class="text" value="<?php echo $this->options['theme_opt_googleAnalyticID']?>" size="12" /><br />
						<a title="<?php esc_attr_e('Link to your Google Analytics account', $this->domain)?>" 
							href="https://www.google.com/analytics/settings/check_status_profile_handler">
							<?php _e('Retrieve it from your Google Analytic account.', $this->domain); ?></a> 
								<p class="info"><?php _e('ID should be of the format <q>UA-XXXXX-YY</q>.', $this->domain); ?></p>
					</td>
				</tr>
			</table>
			</div>
			
			<h3><?php _e('AdRotate integration of theme', $this->domain); ?></h3>
<?php if(is_plugin_active('adrotate/adrotate.php')){?>
			<table class="form-table" summary="AdRotate integration of theme">
				<tr valign="top">
					<th scope="row"><label for="theme_opt_adRotate_group1"><?php _e('Group of ads to display on the right sidebar', $this->domain); ?></label></th> 
					<td>
						<select id="theme_opt_adRotate_group1" name="theme_opt_adRotate_group1">
							<?php echo $this->theme_fn_get_adRotate_group($this->options['theme_opt_adRotate_group1']) ?>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="theme_opt_adRotate_group2"><?php _e('Group of ads to display on the bottom of each page', $this->domain); ?></label></th> 
					<td>
						<select id="theme_opt_adRotate_group2" name="theme_opt_adRotate_group2">
							<?php echo $this->theme_fn_get_adRotate_group($this->options['theme_opt_adRotate_group2']) ?>
						</select>
					</td>
				</tr>
			</table>
<?php }else{ ?>
			<p><i><?php _e("Your blog doesn't use the Adrotate plugin. You can install it then manage your ads form here.", $this->domain); ?> <a href="plugin-install.php?tab=search&amp;s=adrotate"><?php _e('Install it from here if you wish to do so.', $this->domain); ?></a></i></p>
<?php }?>
			<hr style="width: 50%"/>
		<h2 id="save_options"><?php _e('Save Options', $this->domain); ?></h3>
			<p class="submit" style="border: 1px dotted green; padding: 20px; ">
				<input name="save" type="submit" value="<?php _e('Save Options', $this->domain); ?>" tabindex="26" accesskey="S" />  
				<input name="action" type="hidden" value="save" />
				<input name="page_options" type="hidden" value="<?php echo implode(',', $this->options_list) ?>" />
			</p>
		</form>
		<h2 id="reset"><?php _e('Reset Options', $this->domain); ?></h3>
		<p><?php _e('Resetting deletes all theme options. After resetting, default options are loaded but are not stored until you click <i>Save Options</i>. A reset does not affect the actual theme files in any way.', $this->domain); ?></p>
		<form action="<?php echo wp_specialchars( $_SERVER['REQUEST_URI'] ) ?>" method="post">
			<?php wp_nonce_field('theme_fn_reset_options'); echo "\n"; ?>
			<p class="submit" style="border: 1px dotted yellow; padding: 20px; ">
				<input name="reset" type="submit" value="<?php _e('Reset Options', $this->domain); ?>" onclick="return confirm('<?php _e('Click OK to reset. Any changes to these theme options will be lost!', $this->domain); ?>');" tabindex="27" accesskey="R" />
				<input name="action" type="hidden" value="reset" />
				<input name="page_options" type="hidden" value="<?php echo implode(',', $this->options_list) ?>" />
			</p>
		</form>
	</div>
	<?php
	}	
	function theme_fn_donate() { 
		$form = '<form id="paypal" action="https://www.paypal.com/cgi-bin/webscr" method="post" style="float:right;">
			<div id="donate">
				<input type="hidden" name="cmd" value="_s-xclick" />
				<input type="image" id="submit_paypal" name="submit_paypal" src="https://www.paypal.com/en_US/i/btn/x-click-butcc-donate.gif" title="' . esc_attr__('Donate with PayPal - it\'s fast, free and secure!', $this->domain) . '" />
				<img src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1" alt="Donate with PayPal" />
				<input type="hidden" name="hosted_button_id" value="6460410">
			</div>
		</form>' . "\n\t";
		echo $form;
	}

	function theme_fn_select_color(){
		if (isset($_COOKIE['WP_theme_color_preference'])){
			echo $_COOKIE['WP_theme_color_preference'];
		} else { 
			echo $this->options['theme_opt_backgroundColor']; 
		}
	}

function theme_fn_preview_head() {
		echo '
<script src="http://ajax.googleapis.com/ajax/libs/prototype/1.6/prototype.js" type="text/javascript"></script>
<script src="http://ajax.googleapis.com/ajax/libs/scriptaculous/1.8/scriptaculous.js?load=effects,dragdrop,slider" type="text/javascript"></script>

<script type="text/javascript">
//<![CDATA[
function launch_colorBox(name){
	if($(name) == null){
		$$("body")[0].insert(new Element("div", {id:name, className:name}))
		var color_actuel = find_bodyBack();
		new Ajax.Updater(name, "'.get_bloginfo('template_url').'/color_picker/color_picker.php?preload="+color_actuel,  {evalScripts:true, postBody:"type=noscript" })
	}
}

function find_bodyBack(){
	return Try.these(
		function(){return document.defaultView.getComputedStyle(document.body, "").getPropertyValue("background-color");	},
		function(){return document.body.style.backgroundColor;	},
		function(){return document.body.bgColor;	},
		function(){return document.body.background;	}
	);
}
Event.observe(window, "load", function() {
	launch_colorBox("ChooseColorBox");
	Event.observe($("TB_closeWindowButton"), "click", function() {
	  	window.location = "'.get_bloginfo('wpurl').'/wp-admin/themes.php?page=functions.php&theme_opt_backgroundColor="+clr;
	});
});
// ]]>
</script>';
	return;
}


	/*==== Render color box in edit pages ====*/
	function theme_fn_edit_box($post){
		$background_color_use = get_post_meta($post->ID, 'back_color_used', true);
		$background_color = get_post_meta($post->ID, 'back_color', true);
?>
	<label for="back_color_used"><?php _e('I want to use a specific color for the theme background of this post ?', $this->domain) ?></label>
	<input type="hidden" id="back_color_used" value="no" name="back_color_used"/>
	<input type="checkbox" <?php if($background_color_use == 'yes'){ echo 'checked="true"';}?> id="back_color_used" value="yes" name="back_color_used"/>
	<br />
	<label for="back_color"><?php _e('Type in the color or use the color picker to select it :', $this->domain) ?></label>
	<input id="back_color" name="back_color" type="text"  value="<?php echo $background_color?>" size="7" />

	<button onclick="javascript: $('showColorPicker').toggle(); return false;"><?php _e('Show color picker', $this->domain) ?></button>
	<br />
	<br />
	
	<div id="showColorPicker" style="display:none">
		<?php require "color_picker/color_picker.php"; ?>
	</div>
		
<script type="text/javascript">
//<![CDATA[
setBackColor = function(){
	if (document.body.style.backgroundColor != "rgb(255, 255, 255)"){
		document.body.style.backgroundColor = '#FFFFFF';
	}else{
		document.body.style.backgroundColor = $('back_color').value;
	}
}
$('cp_hexBox').value = $("back_color").value;
hexBoxChanged();
<?php if ($background_color_use != 'yes'){echo 'setBackColor();';} ?>

Event.observe($$('input#back_color_used[type=checkbox]')[0], 'click', setBackColor);
Event.observe($("showColorPicker"), "mouseup", function() {
  	$('back_color').value = $("cp_hexBox").value;});
Event.observe($("back_color"), "focus", function() {
  	$('showColorPicker').show();});
Event.observe($("cp_OK"), "click", function() {
  	$('back_color').value = $("cp_hexBox").value;
  	$('showColorPicker').hide();});
Event.observe($("cp_Reset"), "click", function() {
  	$('showColorPicker').hide();});
// ]]>
</script>		
		
<?php		
	}
	
	function theme_fn_save_box_data($post_id){
		$background_color_use = $_POST['back_color_used'];
		$background_color = $_POST['back_color'];
		update_post_meta($post_id, 'back_color_used', $background_color_use);
		if ($background_color_use == 'yes'){
			update_post_meta($post_id, 'back_color', $background_color);
		}		
		return;
	}

	function theme_fn_get_adRotate_group($selected){
		global $wpdb;
		$ret = '<option value="0">I want no ads there</option>';
		$groups = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."adrotate_groups` WHERE `id` > 0");
		foreach ($groups as $group){
			unset($sel);
			if ($selected == $group->id) { $sel = 'selected="selected"'; } 
			$ret .= "<option value='$group->id' $sel>$group->name</option>";
		}
		return $ret;	
	}
	
	function theme_fn_get_background_image($selected, $dir = 'backgrounds'){
		$ret = '';
		$directory = $this->theme_path.'/img/'.$dir;
		if ($handle = opendir($directory)) {
		    /* This is the correct way to loop over the directory. */
		    while (false !== ($file = readdir($handle))) {
		    	if(is_file($directory.'/'.$file)){
					unset($sel);
					if ($selected == $file) { $sel = 'selected="selected"'; } 
					$ret .= "<option value='$file' $sel>$file</option>";
		    	}
		    }
		    closedir($handle);
		}
		return $ret;	
	}
	
	/*==== Used in postTemplate.php - Get images attached to the post ====*/
	function theme_fn_get_post_first_image(){
		global $post;
		$args = array(
			'post_type' => 'attachment',
			'post_mime_type' => 'image',
			'numberposts' => -1,
		    'order' => 'ASC',
			'post_status' => null,
			'post_parent' => $post->ID
		);
		$attachments = get_posts($args);
		if ($attachments) {
			foreach ($attachments as $attachment) {
				$this->first_post_img = wp_get_attachment_thumb_url( $attachment->ID );
				return true;
				break;
			}     
		}
		return false;
	}

	/*==== Used in postTemplate.php - Replacement function from the core ====*/
	function theme_fn_get_author_posts_link() {
		global $authordata;
		return sprintf(
			'<a href="%1$s" title="%2$s">%3$s</a>',
			get_author_posts_url( $authordata->ID, $authordata->user_nicename ),
			sprintf( esc_attr__( 'Posts by %s', $this->domain ), esc_attr( get_the_author() ) ),
			get_the_author()
		);
	}

	
}

/* Stupid function to call data inside the class without reconstructuring it */
function theme_ext_check_option($id){
	global $theme_class;
	return $theme_class->options[$id];
}
function theme_ext_domain(){
	global $theme_class;
	return $theme_class->domain;
}


?>